]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
test: give unique timestamps to messages
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 #
4 # This program is free software: you can redistribute it and/or modify
5 # it under the terms of the GNU General Public License as published by
6 # the Free Software Foundation, either version 2 of the License, or
7 # (at your option) any later version.
8 #
9 # This program is distributed in the hope that it will be useful,
10 # but WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
12 # GNU General Public License for more details.
13 #
14 # You should have received a copy of the GNU General Public License
15 # along with this program.  If not, see http://www.gnu.org/licenses/ .
16
17 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
18     echo "Error: The notmuch test suite requires a bash version >= 4.0"
19     echo "due to use of associative arrays within the test suite."
20     echo "Please try again with a newer bash (or help us fix the"
21     echo "test suite to be more portable). Thanks."
22     exit 1
23 fi
24
25 # Make sure echo builtin does not expand backslash-escape sequences by default.
26 shopt -u xpg_echo
27
28 # if --tee was passed, write the output not only to the terminal, but
29 # additionally to the file test-results/$BASENAME.out, too.
30 case "$GIT_TEST_TEE_STARTED, $* " in
31 done,*)
32         # do not redirect again
33         ;;
34 *' --tee '*|*' --va'*)
35         mkdir -p test-results
36         BASE=test-results/$(basename "$0" .sh)
37         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
38          echo $? > $BASE.exit) | tee $BASE.out
39         test "$(cat $BASE.exit)" = 0
40         exit
41         ;;
42 esac
43
44 # Keep the original TERM for say_color and test_emacs
45 ORIGINAL_TERM=$TERM
46
47 # dtach(1) provides more capable terminal environment to anything
48 # that requires more than dumb terminal...
49 [ x"${TERM:-dumb}" = xdumb ] && DTACH_TERM=vt100 || DTACH_TERM=$TERM
50
51 # For repeatability, reset the environment to known value.
52 LANG=C
53 LC_ALL=C
54 PAGER=cat
55 TZ=UTC
56 TERM=dumb
57 export LANG LC_ALL PAGER TERM TZ
58 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
59 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
60       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
61     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
62     exit 1
63 fi
64 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
65 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
66
67 # Protect ourselves from common misconfiguration to export
68 # CDPATH into the environment
69 unset CDPATH
70
71 unset GREP_OPTIONS
72
73 # Convenience
74 #
75 # A regexp to match 5 and 40 hexdigits
76 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
77 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
78
79 _x04='[0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
80 _x32="$_x04$_x04$_x04$_x04$_x04$_x04$_x04$_x04"
81
82 # Each test should start with something like this, after copyright notices:
83 #
84 # test_description='Description of this test...
85 # This test checks if command xyzzy does the right thing...
86 # '
87 # . ./test-lib.sh
88 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
89                 TERM=$ORIGINAL_TERM &&
90                 export TERM &&
91                 [ -t 1 ] &&
92                 tput bold >/dev/null 2>&1 &&
93                 tput setaf 1 >/dev/null 2>&1 &&
94                 tput sgr0 >/dev/null 2>&1
95         ) &&
96         color=t
97
98 while test "$#" -ne 0
99 do
100         case "$1" in
101         -d|--d|--de|--deb|--debu|--debug)
102                 debug=t; shift ;;
103         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
104                 immediate=t; shift ;;
105         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
106                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
107         -h|--h|--he|--hel|--help)
108                 help=t; shift ;;
109         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
110                 verbose=t; shift ;;
111         -q|--q|--qu|--qui|--quie|--quiet)
112                 quiet=t; shift ;;
113         --with-dashes)
114                 with_dashes=t; shift ;;
115         --no-color)
116                 color=; shift ;;
117         --no-python)
118                 # noop now...
119                 shift ;;
120         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
121                 valgrind=t; verbose=t; shift ;;
122         --tee)
123                 shift ;; # was handled already
124         --root=*)
125                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
126                 shift ;;
127         *)
128                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
129         esac
130 done
131
132 if test -n "$debug"; then
133     print_subtest () {
134         printf " %-4s" "[$((test_count - 1))]"
135     }
136 else
137     print_subtest () {
138         true
139     }
140 fi
141
142 if test -n "$color"; then
143         say_color () {
144                 (
145                 TERM=$ORIGINAL_TERM
146                 export TERM
147                 case "$1" in
148                         error) tput bold; tput setaf 1;; # bold red
149                         skip)  tput bold; tput setaf 2;; # bold green
150                         pass)  tput setaf 2;;            # green
151                         info)  tput setaf 3;;            # brown
152                         *) test -n "$quiet" && return;;
153                 esac
154                 shift
155                 printf " "
156                 printf "$@"
157                 tput sgr0
158                 print_subtest
159                 )
160         }
161 else
162         say_color() {
163                 test -z "$1" && test -n "$quiet" && return
164                 shift
165                 printf " "
166                 printf "$@"
167                 print_subtest
168         }
169 fi
170
171 error () {
172         say_color error "error: $*\n"
173         GIT_EXIT_OK=t
174         exit 1
175 }
176
177 say () {
178         say_color info "$*"
179 }
180
181 test "${test_description}" != "" ||
182 error "Test script did not set test_description."
183
184 if test "$help" = "t"
185 then
186         echo "Tests ${test_description}"
187         exit 0
188 fi
189
190 echo $(basename "$0"): "Testing ${test_description}"
191
192 exec 5>&1
193
194 test_failure=0
195 test_count=0
196 test_fixed=0
197 test_broken=0
198 test_success=0
199
200 _die_common () {
201         code=$?
202         trap - EXIT
203         set +ex
204         rm -rf "$TEST_TMPDIR"
205 }
206
207 die () {
208         _die_common
209         if test -n "$GIT_EXIT_OK"
210         then
211                 exit $code
212         else
213                 exec >&5
214                 say_color error '%-6s' FATAL
215                 echo " $test_subtest_name"
216                 echo
217                 echo "Unexpected exit while executing $0. Exit code $code."
218                 exit 1
219         fi
220 }
221
222 die_signal () {
223         _die_common
224         echo >&5 "FATAL: $0: interrupted by signal" $((code - 128))
225         exit $code
226 }
227
228 GIT_EXIT_OK=
229 # Note: TEST_TMPDIR *NOT* exported!
230 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
231 trap 'die' EXIT
232 trap 'die_signal' HUP INT TERM
233
234 test_decode_color () {
235         sed     -e 's/.\[1m/<WHITE>/g' \
236                 -e 's/.\[31m/<RED>/g' \
237                 -e 's/.\[32m/<GREEN>/g' \
238                 -e 's/.\[33m/<YELLOW>/g' \
239                 -e 's/.\[34m/<BLUE>/g' \
240                 -e 's/.\[35m/<MAGENTA>/g' \
241                 -e 's/.\[36m/<CYAN>/g' \
242                 -e 's/.\[m/<RESET>/g'
243 }
244
245 q_to_nul () {
246         perl -pe 'y/Q/\000/'
247 }
248
249 q_to_cr () {
250         tr Q '\015'
251 }
252
253 append_cr () {
254         sed -e 's/$/Q/' | tr Q '\015'
255 }
256
257 remove_cr () {
258         tr '\015' Q | sed -e 's/Q$//'
259 }
260
261 # Generate a new message in the mail directory, with a unique message
262 # ID and subject. The message is not added to the index.
263 #
264 # After this function returns, the filename of the generated message
265 # is available as $gen_msg_filename and the message ID is available as
266 # $gen_msg_id .
267 #
268 # This function supports named parameters with the bash syntax for
269 # assigning a value to an associative array ([name]=value). The
270 # supported parameters are:
271 #
272 #  [dir]=directory/of/choice
273 #
274 #       Generate the message in directory 'directory/of/choice' within
275 #       the mail store. The directory will be created if necessary.
276 #
277 #  [filename]=name
278 #
279 #       Store the message in file 'name'. The default is to store it
280 #       in 'msg-<count>', where <count> is three-digit number of the
281 #       message.
282 #
283 #  [body]=text
284 #
285 #       Text to use as the body of the email message
286 #
287 #  '[from]="Some User <user@example.com>"'
288 #  '[to]="Some User <user@example.com>"'
289 #  '[subject]="Subject of email message"'
290 #  '[date]="RFC 822 Date"'
291 #
292 #       Values for email headers. If not provided, default values will
293 #       be generated instead.
294 #
295 #  '[cc]="Some User <user@example.com>"'
296 #  [reply-to]=some-address
297 #  [in-reply-to]=<message-id>
298 #  [references]=<message-id>
299 #  [content-type]=content-type-specification
300 #  '[header]=full header line, including keyword'
301 #
302 #       Additional values for email headers. If these are not provided
303 #       then the relevant headers will simply not appear in the
304 #       message.
305 #
306 #  '[id]=message-id'
307 #
308 #       Controls the message-id of the created message.
309 gen_msg_cnt=0
310 gen_msg_filename=""
311 gen_msg_id=""
312 generate_message ()
313 {
314     # This is our (bash-specific) magic for doing named parameters
315     local -A template="($@)"
316     local additional_headers
317
318     gen_msg_cnt=$((gen_msg_cnt + 1))
319     if [ -z "${template[filename]}" ]; then
320         gen_msg_name="msg-$(printf "%03d" $gen_msg_cnt)"
321     else
322         gen_msg_name=${template[filename]}
323     fi
324
325     if [ -z "${template[id]}" ]; then
326         gen_msg_id="${gen_msg_name%:2,*}@notmuch-test-suite"
327     else
328         gen_msg_id="${template[id]}"
329     fi
330
331     if [ -z "${template[dir]}" ]; then
332         gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
333     else
334         gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
335         mkdir -p "$(dirname "$gen_msg_filename")"
336     fi
337
338     if [ -z "${template[body]}" ]; then
339         template[body]="This is just a test message (#${gen_msg_cnt})"
340     fi
341
342     if [ -z "${template[from]}" ]; then
343         template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
344     fi
345
346     if [ -z "${template[to]}" ]; then
347         template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
348     fi
349
350     if [ -z "${template[subject]}" ]; then
351         if [ -n "$test_subtest_name" ]; then
352             template[subject]="$test_subtest_name"
353         else
354             template[subject]="Test message #${gen_msg_cnt}"
355         fi
356     fi
357
358     if [ -z "${template[date]}" ]; then
359         # we use decreasing timestamps here for historical reasons;
360         # the existing test suite when we converted to unique timestamps just
361         # happened to have signicantly fewer failures with that choice.
362         template[date]=$(TZ=UTC printf "%(%a, %d %b %Y %T %z)T\n" \
363                         $((978709437 - gen_msg_cnt)))
364     fi
365
366     additional_headers=""
367     if [ ! -z "${template[header]}" ]; then
368         additional_headers="${template[header]}
369 ${additional_headers}"
370     fi
371
372     if [ ! -z "${template[reply-to]}" ]; then
373         additional_headers="Reply-To: ${template[reply-to]}
374 ${additional_headers}"
375     fi
376
377     if [ ! -z "${template[in-reply-to]}" ]; then
378         additional_headers="In-Reply-To: ${template[in-reply-to]}
379 ${additional_headers}"
380     fi
381
382     if [ ! -z "${template[cc]}" ]; then
383         additional_headers="Cc: ${template[cc]}
384 ${additional_headers}"
385     fi
386
387     if [ ! -z "${template[bcc]}" ]; then
388         additional_headers="Bcc: ${template[bcc]}
389 ${additional_headers}"
390     fi
391
392     if [ ! -z "${template[references]}" ]; then
393         additional_headers="References: ${template[references]}
394 ${additional_headers}"
395     fi
396
397     if [ ! -z "${template[content-type]}" ]; then
398         additional_headers="Content-Type: ${template[content-type]}
399 ${additional_headers}"
400     fi
401
402     if [ ! -z "${template[content-transfer-encoding]}" ]; then
403         additional_headers="Content-Transfer-Encoding: ${template[content-transfer-encoding]}
404 ${additional_headers}"
405     fi
406
407     # Note that in the way we're setting it above and using it below,
408     # `additional_headers' will also serve as the header / body separator
409     # (empty line in between).
410
411     cat <<EOF >"$gen_msg_filename"
412 From: ${template[from]}
413 To: ${template[to]}
414 Message-Id: <${gen_msg_id}>
415 Subject: ${template[subject]}
416 Date: ${template[date]}
417 ${additional_headers}
418 ${template[body]}
419 EOF
420 }
421
422 # Generate a new message and add it to the database.
423 #
424 # All of the arguments and return values supported by generate_message
425 # are also supported here, so see that function for details.
426 add_message ()
427 {
428     generate_message "$@" &&
429     notmuch new > /dev/null
430 }
431
432 # Deliver a message with emacs and add it to the database
433 #
434 # Uses emacs to generate and deliver a message to the mail store.
435 # Accepts arbitrary extra emacs/elisp functions to modify the message
436 # before sending, which is useful to doing things like attaching files
437 # to the message and encrypting/signing.
438 emacs_deliver_message ()
439 {
440     local subject="$1"
441     local body="$2"
442     shift 2
443     # before we can send a message, we have to prepare the FCC maildir
444     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
445     # eval'ing smtp-dummy --background will set smtp_dummy_pid
446     smtp_dummy_pid=
447     eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
448     test -n "$smtp_dummy_pid" || return 1
449
450     test_emacs \
451         "(let ((message-send-mail-function 'message-smtpmail-send-it)
452                (mail-host-address \"example.com\")
453                (smtpmail-smtp-server \"localhost\")
454                (smtpmail-smtp-service \"25025\"))
455            (notmuch-hello)
456            (notmuch-mua-mail)
457            (message-goto-to)
458            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
459            (message-goto-subject)
460            (insert \"${subject}\")
461            (message-goto-body)
462            (insert \"${body}\")
463            $@
464            (message-send-and-exit))"
465
466     # In case message was sent properly, client waits for confirmation
467     # before exiting and resuming control here; therefore making sure
468     # that server exits by sending (KILL) signal to it is safe.
469     kill -9 $smtp_dummy_pid
470     notmuch new >/dev/null
471 }
472
473 # Generate a corpus of email and add it to the database.
474 #
475 # This corpus is fixed, (it happens to be 50 messages from early in
476 # the history of the notmuch mailing list), which allows for reliably
477 # testing commands that need to operate on a not-totally-trivial
478 # number of messages.
479 add_email_corpus ()
480 {
481     rm -rf ${MAIL_DIR}
482     if [ -d $TEST_DIRECTORY/corpus.mail ]; then
483         cp -a $TEST_DIRECTORY/corpus.mail ${MAIL_DIR}
484     else
485         cp -a $TEST_DIRECTORY/corpus ${MAIL_DIR}
486         notmuch new >/dev/null
487         cp -a ${MAIL_DIR} $TEST_DIRECTORY/corpus.mail
488     fi
489 }
490
491 test_begin_subtest ()
492 {
493     if [ -n "$inside_subtest" ]; then
494         exec 1>&6 2>&7          # Restore stdout and stderr
495         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
496     fi
497     test_subtest_name="$1"
498     test_reset_state_
499     # Remember stdout and stderr file descriptors and redirect test
500     # output to the previously prepared file descriptors 3 and 4 (see
501     # below)
502     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
503     exec 6>&1 7>&2 >&3 2>&4
504     inside_subtest=t
505 }
506
507 # Pass test if two arguments match
508 #
509 # Note: Unlike all other test_expect_* functions, this function does
510 # not accept a test name. Instead, the caller should call
511 # test_begin_subtest before calling this function in order to set the
512 # name.
513 test_expect_equal ()
514 {
515         exec 1>&6 2>&7          # Restore stdout and stderr
516         inside_subtest=
517         test "$#" = 3 && { prereq=$1; shift; } || prereq=
518         test "$#" = 2 ||
519         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
520
521         output="$1"
522         expected="$2"
523         if ! test_skip "$test_subtest_name"
524         then
525                 if [ "$output" = "$expected" ]; then
526                         test_ok_
527                 else
528                         testname=$this_test.$test_count
529                         echo "$expected" > $testname.expected
530                         echo "$output" > $testname.output
531                         test_failure_ "$(diff -u $testname.expected $testname.output)"
532                 fi
533     fi
534 }
535
536 # Like test_expect_equal, but takes two filenames.
537 test_expect_equal_file ()
538 {
539         exec 1>&6 2>&7          # Restore stdout and stderr
540         inside_subtest=
541         test "$#" = 3 && { prereq=$1; shift; } || prereq=
542         test "$#" = 2 ||
543         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
544
545         file1="$1"
546         basename1=`basename "$file1"`
547         file2="$2"
548         basename2=`basename "$file2"`
549         if ! test_skip "$test_subtest_name"
550         then
551                 if diff -q "$file1" "$file2" >/dev/null ; then
552                         test_ok_
553                 else
554                         testname=$this_test.$test_count
555                         cp "$file1" "$testname.$basename1"
556                         cp "$file2" "$testname.$basename2"
557                         test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
558                 fi
559     fi
560 }
561
562 # Like test_expect_equal, but arguments are JSON expressions to be
563 # canonicalized before diff'ing.  If an argument cannot be parsed, it
564 # is used unchanged so that there's something to diff against.
565 test_expect_equal_json () {
566     # The test suite forces LC_ALL=C, but this causes Python 3 to
567     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
568     # override Python's stdio encoding defaults.
569     output=$(echo "$1" | PYTHONIOENCODING=utf-8 python -mjson.tool \
570         || echo "$1")
571     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 python -mjson.tool \
572         || echo "$2")
573     shift 2
574     test_expect_equal "$output" "$expected" "$@"
575 }
576
577 test_emacs_expect_t () {
578         test "$#" = 2 && { prereq=$1; shift; } || prereq=
579         test "$#" = 1 ||
580         error "bug in the test script: not 1 or 2 parameters to test_emacs_expect_t"
581
582         # Run the test.
583         if ! test_skip "$test_subtest_name"
584         then
585                 test_emacs "(notmuch-test-run $1)" >/dev/null
586
587                 # Restore state after the test.
588                 exec 1>&6 2>&7          # Restore stdout and stderr
589                 inside_subtest=
590
591                 # Report success/failure.
592                 result=$(cat OUTPUT)
593                 if [ "$result" = t ]
594                 then
595                         test_ok_
596                 else
597                         test_failure_ "${result}"
598                 fi
599         else
600                 # Restore state after the (non) test.
601                 exec 1>&6 2>&7          # Restore stdout and stderr
602                 inside_subtest=
603         fi
604 }
605
606 NOTMUCH_NEW ()
607 {
608     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
609 }
610
611 notmuch_search_sanitize ()
612 {
613     perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
614 }
615
616 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
617 notmuch_show_sanitize ()
618 {
619     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
620 }
621 notmuch_show_sanitize_all ()
622 {
623     sed \
624         -e 's| filename:.*| filename:XXXXX|' \
625         -e 's| id:[^ ]* | id:XXXXX |' | \
626         notmuch_date_sanitize
627 }
628
629 notmuch_json_show_sanitize ()
630 {
631     sed \
632         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
633         -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
634         -e 's|"filename": "/[^"]*",|"filename": "YYYYY",|g' \
635         -e 's|"timestamp": 97.......|"timestamp": 42|g'
636 }
637
638 notmuch_emacs_error_sanitize ()
639 {
640     local command=$1
641     shift
642     for file in "$@"; do
643         echo "=== $file ==="
644         cat "$file"
645     done | sed  \
646         -e 's/^\[.*\]$/[XXX]/' \
647         -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
648 }
649
650 notmuch_date_sanitize ()
651 {
652     sed \
653         -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
654 }
655 # End of notmuch helper functions
656
657 # Use test_set_prereq to tell that a particular prerequisite is available.
658 # The prerequisite can later be checked for in two ways:
659 #
660 # - Explicitly using test_have_prereq.
661 #
662 # - Implicitly by specifying the prerequisite tag in the calls to
663 #   test_expect_{success,failure,code}.
664 #
665 # The single parameter is the prerequisite tag (a simple word, in all
666 # capital letters by convention).
667
668 test_set_prereq () {
669         satisfied="$satisfied$1 "
670 }
671 satisfied=" "
672
673 test_have_prereq () {
674         case $satisfied in
675         *" $1 "*)
676                 : yes, have it ;;
677         *)
678                 ! : nope ;;
679         esac
680 }
681
682 declare -A test_missing_external_prereq_
683 declare -A test_subtest_missing_external_prereq_
684
685 # declare prerequisite for the given external binary
686 test_declare_external_prereq () {
687         binary="$1"
688         test "$#" = 2 && name=$2 || name="$binary(1)"
689
690         if ! hash $binary 2>/dev/null; then
691                 test_missing_external_prereq_["${binary}"]=t
692                 eval "
693 $binary () {
694         test_subtest_missing_external_prereq_[\"${name}\"]=t
695         false
696 }"
697         fi
698 }
699
700 # Explicitly require external prerequisite.  Useful when binary is
701 # called indirectly (e.g. from emacs).
702 # Returns success if dependency is available, failure otherwise.
703 test_require_external_prereq () {
704         binary="$1"
705         if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
706                 # dependency is missing, call the replacement function to note it
707                 eval "$binary"
708         else
709                 true
710         fi
711 }
712
713 # You are not expected to call test_ok_ and test_failure_ directly, use
714 # the text_expect_* functions instead.
715
716 test_ok_ () {
717         if test "$test_subtest_known_broken_" = "t"; then
718                 test_known_broken_ok_
719                 return
720         fi
721         test_success=$(($test_success + 1))
722         say_color pass "%-6s" "PASS"
723         echo " $test_subtest_name"
724 }
725
726 test_failure_ () {
727         if test "$test_subtest_known_broken_" = "t"; then
728                 test_known_broken_failure_ "$@"
729                 return
730         fi
731         test_failure=$(($test_failure + 1))
732         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
733         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
734         return 1
735 }
736
737 test_failure_message_ () {
738         say_color error "%-6s" "$1"
739         echo " $2"
740         shift 2
741         echo "$@" | sed -e 's/^/        /'
742         if test "$verbose" != "t"; then cat test.output; fi
743 }
744
745 test_known_broken_ok_ () {
746         test_reset_state_
747         test_fixed=$(($test_fixed+1))
748         say_color pass "%-6s" "FIXED"
749         echo " $test_subtest_name"
750 }
751
752 test_known_broken_failure_ () {
753         test_reset_state_
754         test_broken=$(($test_broken+1))
755         test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
756         return 1
757 }
758
759 test_debug () {
760         test "$debug" = "" || eval "$1"
761 }
762
763 test_run_ () {
764         test_cleanup=:
765         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
766         eval >&3 2>&4 "$1"
767         eval_ret=$?
768         eval >&3 2>&4 "$test_cleanup"
769         return 0
770 }
771
772 test_skip () {
773         test_count=$(($test_count+1))
774         to_skip=
775         for skp in $NOTMUCH_SKIP_TESTS
776         do
777                 case $this_test.$test_count in
778                 $skp)
779                         to_skip=t
780                 esac
781         done
782         if test -z "$to_skip" && test -n "$prereq" &&
783            ! test_have_prereq "$prereq"
784         then
785                 to_skip=t
786         fi
787         case "$to_skip" in
788         t)
789                 test_report_skip_ "$@"
790                 ;;
791         *)
792                 test_check_missing_external_prereqs_ "$@"
793                 ;;
794         esac
795 }
796
797 test_check_missing_external_prereqs_ () {
798         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
799                 say_color skip >&1 "missing prerequisites: "
800                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
801                 test_report_skip_ "$@"
802         else
803                 false
804         fi
805 }
806
807 test_report_skip_ () {
808         test_reset_state_
809         say_color skip >&3 "skipping test:"
810         echo " $@" >&3
811         say_color skip "%-6s" "SKIP"
812         echo " $1"
813 }
814
815 test_subtest_known_broken () {
816         test_subtest_known_broken_=t
817 }
818
819 test_expect_success () {
820         test "$#" = 3 && { prereq=$1; shift; } || prereq=
821         test "$#" = 2 ||
822         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
823         test_subtest_name="$1"
824         test_reset_state_
825         if ! test_skip "$@"
826         then
827                 test_run_ "$2"
828                 run_ret="$?"
829                 # test_run_ may update missing external prerequisites
830                 test_check_missing_external_prereqs_ "$@" ||
831                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
832                 then
833                         test_ok_
834                 else
835                         test_failure_ "$2"
836                 fi
837         fi
838 }
839
840 test_expect_code () {
841         test "$#" = 4 && { prereq=$1; shift; } || prereq=
842         test "$#" = 3 ||
843         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
844         test_subtest_name="$2"
845         test_reset_state_
846         if ! test_skip "$@"
847         then
848                 test_run_ "$3"
849                 run_ret="$?"
850                 # test_run_ may update missing external prerequisites,
851                 test_check_missing_external_prereqs_ "$@" ||
852                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
853                 then
854                         test_ok_
855                 else
856                         test_failure_ "exit code $eval_ret, expected $1" "$3"
857                 fi
858         fi
859 }
860
861 # test_external runs external test scripts that provide continuous
862 # test output about their progress, and succeeds/fails on
863 # zero/non-zero exit code.  It outputs the test output on stdout even
864 # in non-verbose mode, and announces the external script with "* run
865 # <n>: ..." before running it.  When providing relative paths, keep in
866 # mind that all scripts run in "trash directory".
867 # Usage: test_external description command arguments...
868 # Example: test_external 'Perl API' perl ../path/to/test.pl
869 test_external () {
870         test "$#" = 4 && { prereq=$1; shift; } || prereq=
871         test "$#" = 3 ||
872         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
873         test_subtest_name="$1"
874         shift
875         test_reset_state_
876         if ! test_skip "$test_subtest_name" "$@"
877         then
878                 # Announce the script to reduce confusion about the
879                 # test output that follows.
880                 say_color "" " run $test_count: $descr ($*)"
881                 # Run command; redirect its stderr to &4 as in
882                 # test_run_, but keep its stdout on our stdout even in
883                 # non-verbose mode.
884                 "$@" 2>&4
885                 if [ "$?" = 0 ]
886                 then
887                         test_ok_
888                 else
889                         test_failure_ "$@"
890                 fi
891         fi
892 }
893
894 # Like test_external, but in addition tests that the command generated
895 # no output on stderr.
896 test_external_without_stderr () {
897         # The temporary file has no (and must have no) security
898         # implications.
899         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
900         stderr="$tmp/git-external-stderr.$$.tmp"
901         test_external "$@" 4> "$stderr"
902         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
903         test_subtest_name="no stderr: $1"
904         shift
905         if [ ! -s "$stderr" ]; then
906                 rm "$stderr"
907                 test_ok_
908         else
909                 if [ "$verbose" = t ]; then
910                         output=`echo; echo Stderr is:; cat "$stderr"`
911                 else
912                         output=
913                 fi
914                 # rm first in case test_failure exits.
915                 rm "$stderr"
916                 test_failure_ "$@" "$output"
917         fi
918 }
919
920 # This is not among top-level (test_expect_success)
921 # but is a prefix that can be used in the test script, like:
922 #
923 #       test_expect_success 'complain and die' '
924 #           do something &&
925 #           do something else &&
926 #           test_must_fail git checkout ../outerspace
927 #       '
928 #
929 # Writing this as "! git checkout ../outerspace" is wrong, because
930 # the failure could be due to a segv.  We want a controlled failure.
931
932 test_must_fail () {
933         "$@"
934         test $? -gt 0 -a $? -le 129 -o $? -gt 192
935 }
936
937 # test_cmp is a helper function to compare actual and expected output.
938 # You can use it like:
939 #
940 #       test_expect_success 'foo works' '
941 #               echo expected >expected &&
942 #               foo >actual &&
943 #               test_cmp expected actual
944 #       '
945 #
946 # This could be written as either "cmp" or "diff -u", but:
947 # - cmp's output is not nearly as easy to read as diff -u
948 # - not all diff versions understand "-u"
949
950 test_cmp() {
951         $GIT_TEST_CMP "$@"
952 }
953
954 # This function can be used to schedule some commands to be run
955 # unconditionally at the end of the test to restore sanity:
956 #
957 #       test_expect_success 'test core.capslock' '
958 #               git config core.capslock true &&
959 #               test_when_finished "git config --unset core.capslock" &&
960 #               hello world
961 #       '
962 #
963 # That would be roughly equivalent to
964 #
965 #       test_expect_success 'test core.capslock' '
966 #               git config core.capslock true &&
967 #               hello world
968 #               git config --unset core.capslock
969 #       '
970 #
971 # except that the greeting and config --unset must both succeed for
972 # the test to pass.
973
974 test_when_finished () {
975         test_cleanup="{ $*
976                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
977 }
978
979 test_done () {
980         GIT_EXIT_OK=t
981         test_results_dir="$TEST_DIRECTORY/test-results"
982         mkdir -p "$test_results_dir"
983         test_results_path="$test_results_dir/${0%.sh}"
984
985         echo "total $test_count" >> $test_results_path
986         echo "success $test_success" >> $test_results_path
987         echo "fixed $test_fixed" >> $test_results_path
988         echo "broken $test_broken" >> $test_results_path
989         echo "failed $test_failure" >> $test_results_path
990         echo "" >> $test_results_path
991
992         echo
993
994         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
995
996         if [ "$test_failure" = "0" ]; then
997             if [ "$test_broken" = "0" ]; then
998                 rm -rf "$remove_tmp"
999             fi
1000             exit 0
1001         else
1002             exit 1
1003         fi
1004 }
1005
1006 emacs_generate_script () {
1007         # Construct a little test script here for the benefit of the user,
1008         # (who can easily run "run_emacs" to get the same emacs environment
1009         # for investigating any failures).
1010         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
1011 #!/bin/sh
1012 export PATH=$PATH
1013 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
1014
1015 # Here's what we are using here:
1016 #
1017 # --no-init-file        Don't load users ~/.emacs
1018 #
1019 # --no-site-file        Don't load the site-wide startup stuff
1020 #
1021 # --directory           Ensure that the local elisp sources are found
1022 #
1023 # --load                Force loading of notmuch.el and test-lib.el
1024
1025 exec ${TEST_EMACS} --no-init-file --no-site-file \
1026         --directory "$TEST_DIRECTORY/../emacs" --load notmuch.el \
1027         --directory "$TEST_DIRECTORY" --load test-lib.el \
1028         "\$@"
1029 EOF
1030         chmod a+x "$TMP_DIRECTORY/run_emacs"
1031 }
1032
1033 test_emacs () {
1034         # test dependencies beforehand to avoid the waiting loop below
1035         missing_dependencies=
1036         test_require_external_prereq dtach || missing_dependencies=1
1037         test_require_external_prereq emacs || missing_dependencies=1
1038         test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
1039         test -z "$missing_dependencies" || return
1040
1041         if [ -z "$EMACS_SERVER" ]; then
1042                 emacs_tests="$(basename $0).el"
1043                 if [ -f "$TEST_DIRECTORY/$emacs_tests" ]; then
1044                         load_emacs_tests="--eval '(load \"$emacs_tests\")'"
1045                 else
1046                         load_emacs_tests=
1047                 fi
1048                 server_name="notmuch-test-suite-$$"
1049                 # start a detached session with an emacs server
1050                 # user's TERM (or 'vt100' in case user's TERM is unset, empty
1051                 # or 'dumb') is given to dtach which assumes a minimally
1052                 # VT100-compatible terminal -- and emacs inherits that
1053                 TERM=$DTACH_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
1054                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
1055                                 --no-window-system \
1056                                 $load_emacs_tests \
1057                                 --eval '(setq server-name \"$server_name\")' \
1058                                 --eval '(server-start)' \
1059                                 --eval '(orphan-watchdog $$)'" || return
1060                 EMACS_SERVER="$server_name"
1061                 # wait until the emacs server is up
1062                 until test_emacs '()' >/dev/null 2>/dev/null; do
1063                         sleep 1
1064                 done
1065         fi
1066
1067         # Clear test-output output file.  Most Emacs tests end with a
1068         # call to (test-output).  If the test code fails with an
1069         # exception before this call, the output file won't get
1070         # updated.  Since we don't want to compare against an output
1071         # file from another test, so start out with an empty file.
1072         rm -f OUTPUT
1073         touch OUTPUT
1074
1075         ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(progn $@)"
1076 }
1077
1078 test_python() {
1079         export LD_LIBRARY_PATH=$TEST_DIRECTORY/../lib
1080         export PYTHONPATH=$TEST_DIRECTORY/../bindings/python
1081
1082         # Some distros (e.g. Arch Linux) ship Python 2.* as /usr/bin/python2,
1083         # most others as /usr/bin/python. So first try python2, and fallback to
1084         # python if python2 doesn't exist.
1085         cmd=python2
1086         [[ ${test_missing_external_prereq_[python2]} == t ]] && cmd=python
1087
1088         (echo "import sys; _orig_stdout=sys.stdout; sys.stdout=open('OUTPUT', 'w')"; cat) \
1089                 | $cmd -
1090 }
1091
1092 # Creates a script that counts how much time it is executed and calls
1093 # notmuch.  $notmuch_counter_command is set to the path to the
1094 # generated script.  Use notmuch_counter_value() function to get the
1095 # current counter value.
1096 notmuch_counter_reset () {
1097         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1098         if [ ! -x "$notmuch_counter_command" ]; then
1099                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1100                 cat >"$notmuch_counter_command" <<EOF || return
1101 #!/bin/sh
1102
1103 read count < "$notmuch_counter_state_path"
1104 echo \$((count + 1)) > "$notmuch_counter_state_path"
1105
1106 exec notmuch "\$@"
1107 EOF
1108                 chmod +x "$notmuch_counter_command" || return
1109         fi
1110
1111         echo 0 > "$notmuch_counter_state_path"
1112 }
1113
1114 # Returns the current notmuch counter value.
1115 notmuch_counter_value () {
1116         if [ -r "$notmuch_counter_state_path" ]; then
1117                 read count < "$notmuch_counter_state_path"
1118         else
1119                 count=0
1120         fi
1121         echo $count
1122 }
1123
1124 test_reset_state_ () {
1125         test -z "$test_init_done_" && test_init_
1126
1127         test_subtest_known_broken_=
1128         test_subtest_missing_external_prereq_=()
1129 }
1130
1131 # called once before the first subtest
1132 test_init_ () {
1133         test_init_done_=t
1134
1135         # skip all tests if there were external prerequisites missing during init
1136         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1137 }
1138
1139
1140 . ./test-lib-common.sh
1141
1142 emacs_generate_script
1143
1144
1145 # Use -P to resolve symlinks in our working directory so that the cwd
1146 # in subprocesses like git equals our $PWD (for pathname comparisons).
1147 cd -P "$test" || error "Cannot setup test environment"
1148
1149 if test "$verbose" = "t"
1150 then
1151         exec 4>&2 3>&1
1152 else
1153         exec 4>test.output 3>&4
1154 fi
1155
1156 this_test=${0##*/}
1157 for skp in $NOTMUCH_SKIP_TESTS
1158 do
1159         to_skip=
1160         for skp in $NOTMUCH_SKIP_TESTS
1161         do
1162                 case "$this_test" in
1163                 $skp)
1164                         to_skip=t
1165                 esac
1166         done
1167         case "$to_skip" in
1168         t)
1169                 say_color skip >&3 "skipping test $this_test altogether"
1170                 say_color skip "skip all tests in $this_test"
1171                 test_done
1172         esac
1173 done
1174
1175 # Provide an implementation of the 'yes' utility
1176 yes () {
1177         if test $# = 0
1178         then
1179                 y=y
1180         else
1181                 y="$*"
1182         fi
1183
1184         while echo "$y"
1185         do
1186                 :
1187         done
1188 }
1189
1190 # Fix some commands on Windows
1191 case $(uname -s) in
1192 *MINGW*)
1193         # Windows has its own (incompatible) sort and find
1194         sort () {
1195                 /usr/bin/sort "$@"
1196         }
1197         find () {
1198                 /usr/bin/find "$@"
1199         }
1200         sum () {
1201                 md5sum "$@"
1202         }
1203         # git sees Windows-style pwd
1204         pwd () {
1205                 builtin pwd -W
1206         }
1207         # no POSIX permissions
1208         # backslashes in pathspec are converted to '/'
1209         # exec does not inherit the PID
1210         ;;
1211 *)
1212         test_set_prereq POSIXPERM
1213         test_set_prereq BSLASHPSPEC
1214         test_set_prereq EXECKEEPSPID
1215         ;;
1216 esac
1217
1218 test -z "$NO_PERL" && test_set_prereq PERL
1219 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1220
1221 # test whether the filesystem supports symbolic links
1222 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1223 rm -f y
1224
1225 # declare prerequisites for external binaries used in tests
1226 test_declare_external_prereq dtach
1227 test_declare_external_prereq emacs
1228 test_declare_external_prereq ${TEST_EMACSCLIENT}
1229 test_declare_external_prereq gdb
1230 test_declare_external_prereq gpg
1231 test_declare_external_prereq python
1232 test_declare_external_prereq python2